#include "pt.h"

// this function returns elements of the triangle given by coordinates x and y from table A

unsigned long int get_elem(int x, int y, unsigned long int A[][M]) {
    if (x < 0 || y < 0) return 0;
    if (x == 0 || y == 0) return 1;
    if ((x == 1 && y == 0) || (x == 0 && y == 1)) return 1;
    return A[x][y];
}

// writes specified number of spaces to standard output

void write_spaces(int x) {
    int i;
    for (i = 0; i < x; i++) printf(" ");
}

// gets width of the given row in Pascal's triangle

int get_row_width(int x, unsigned long int A[][M]) {
    int j;
    int w = 0;
    for (j = 0; j < x; j++){
        w += log10(A[j][x-j]) + 1;
	//printf("log=%u\n",A[j][x-j]);
    }
    return w;
}

// displays the triangle

void show_triangle(unsigned long int A[][M], int size) {
    int i, j;
    for (i = 0; i < size; i++) {
        write_spaces((size - i + get_row_width(size - 1, A) - get_row_width(i, A)) / 2);
        for (j = 0; j <= i; j++){
            printf ("%u ", A[j][i-j]);
        }
        printf("\n");
    }
}

// calculates n over k

int noverk(int n, int k, unsigned long int A[][M]) {
    return n >= k ? A[n-k][k-1+1] : 0;
}

